
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Linked List Cycle II / 憋错料</title>

    <meta name="description" content="Linked List Cycle II Given a linked list, return the node where the cycle begins. If there is no cycle, return null. Follow up: Can you solve it without using extra space? 这道题其实是一个数学题,先检测出是不是有环,在有环的情况下slow再走x步(x是环外的节点个数)就可以到达环的开始点. /** * Definition for singly-linked list">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Linked List Cycle II</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<pre>Given a linked list, return the node where the cycle begins. If there is no cycle, return null.

Follow up:
Can you solve it without using extra space?</pre>
<p>这道题其实是一个数学题，先检测出是不是有环，在有环的情况下slow再走x步（x是环外的节点个数）就可以到达环的开始点。</p>
<pre>/**
 * Definition for singly-linked list.
 * class ListNode {
 *     int val;
 *     ListNode next;
 *     ListNode(int x) {
 *         val = x;
 *         next = null;
 *     }
 * }
 */
public class Solution {
    public ListNode detectCycle(ListNode head) {
        if(head == null || head.next == null){
            return null;
        }

        ListNode fast = head;
        ListNode slow = head;

        while(fast != null &amp;&amp; fast.next !=null){
            fast = fast.next.next;
            slow = slow.next;
            if(fast == slow){
                break;
            }
        }

        if(fast != slow){
            return null;
        }
        fast = head;
        while(fast != slow){
            fast = fast.next;
            slow = slow.next;
        }
        return fast;

    }
}</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-29 09:39:15 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Linked List Cycle II的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGGlmbM.html" rel="bookmark">Leetcode 链表 Linked List Cycle II</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文为senlie原创,转载请保留此地址:http://blog.csdn.net/zhengsenlie Linked List Cycle II Total Accepted: 20444 Total Submissions: 66195My Submissions Given a linked list, return the node where the cycle begins. If there is no cycle, return null. Follow up: Can you			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02blJD0.html" rel="bookmark">LeetCode Linked List Cycle II</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				/** * Definition for singly-linked list. * struct ListNode { * int val; * ListNode *next; * ListNode(int x) : val(x), next(NULL) {} * }; */ class Solution { public: ListNode *detectCycle(ListNode *head) { ListNode* fast = head; ListNode* slow = head;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoYony3.html" rel="bookmark">LeetCode141 Linked List Cycle&period; LeetCode142 Linked List Cycle II</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				链表相关题 141. Linked List Cycle Given a linked list, determine if it has a cycle in it. Follow up:Can you solve it without using extra space? (Easy) 分析: 采用快慢指针,一个走两步,一个走一步,快得能追上慢的说明有环,走到nullptr还没有相遇说明没有环. 代码: 1 /** 2 * Definition for singly-linked list.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lGRpXM.html" rel="bookmark">LeetCode之&OpenCurlyDoubleQuote;链表&rdquo;：Linked List Cycle &amp;amp&semi;&amp;amp&semi; Linked List Cycle II</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. Linked List Cycle 题目链接 题目要求: Given a linked list, determine if it has a cycle in it. Follow up: Can you solve it without using extra space? 刚看到这道题,很容易写出下边的程序: 1 bool hasCycle(ListNode *head) { 2 ListNode *a = head, *b = head; 3 while(a) 4 { 5 b =			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLjPBQ3.html" rel="bookmark">LeetCode&colon; Linked List Cycle ii 解题报告</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linked List Cycle ii Given a linked list, return the node where the cycle begins. If there is no cycle, return null. Follow up: Can you solve it without using extra space? SOLUTION 1: 最开始的想法和 Linked List Cycle这一题一样. SOLUTION 2: 同样是两个指针,一快一慢,相遇时跳出循环,只			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pRDQK0.html" rel="bookmark">leetcode&period; Linked List Cycle &amp;amp&semi;&amp;amp&semi; Linked List Cycle ii</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Given a linked list, determine if it has a cycle in it. Follow up:Can you solve it without using extra space? 使用双指针fast和slow,fast每次走两步,slow每次走一步,如果fast追上slow则存在环,否则不存在. 1 bool hasCycle(ListNode *head) 2 { 3 ListNode *slow = head, *fast = head; 4 whil			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0j7Z1V3.html" rel="bookmark">LeetCode&colon; Linked List Cycle II &lbrack;142&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[题目] Given a linked list, return the node where the cycle begins. If there is no cycle, return null. Follow up: Can you solve it without using extra space? [题意] 给定一个单向链表,如果链表有环,则返回环开始的位置. [思路] 仍然是维护两个指针, p1, p2, p1每次走一步, p2每次走两步 假设进入环之前要走X步,环长为y步,p2第			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02LKKB4.html" rel="bookmark">Linked List Cycle &amp;amp&semi;&amp;amp&semi; Linked List Cycle II</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Given a linked list, return the node where the cycle begins. If there is no cycle, return null. Note: Do not modify the linked list. Follow up:Can you solve it without using extra space? Subscribe to see which companies asked this question 查看是否有环,快慢两			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xrBED4.html" rel="bookmark">&lbrack;LeetCode 题解&rsqb;&colon; Linked List Cycle II</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Given a linked list, return the node where the cycle begins. If there is no cycle, return null. Follow up:Can you solve it without using extra space? 题意: 给定一个链表,找到环起始的位置.如果环不存在,返回NULL. 分析: (1)首先要判断该链表是否有环.如果没有环,那么返回NULL. (2)其次,当已知环存在后,寻找环起始的位置. 思路: (			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QwpKQ0.html" rel="bookmark">&lbrack;LeetCode&rsqb;&lbrack;JavaScript&rsqb;Linked List Cycle II</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linked List Cycle II Given a linked list, return the node where the cycle begins. If there is no cycle, return null. Note: Do not modify the linked list. Follow up:Can you solve it without using extra space? https://leetcode.com/problems/linked-list-			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0e7LZ4.html" rel="bookmark" class="title">黑客入门初识</a>
					<div>
						学习黑客知识前,首先要了解黑客常见的术语与命令,当然,进程.端口.IP地址等基础知识也是很必要的. 什么是黑客? 有些人习惯性认为黑客是电脑的侵入者,而且很多时候代表的是一个贬义的名词,其实黑客指代的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Z0YPxvM.html" rel="bookmark" class="title">HP system management tools centos 7</a>
					<div>
						基本思路就是,手动配置好HP的yum源,更新一下yum,不用管报错信息,直接忽略,然后用yum安装你需要的软件,即可,以下是基本步骤: cd /etc/yum.repos.d vi hp.repo [ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzaWp84.html" rel="bookmark" class="title">Java：String和Date、Timestamp之间的转换</a>
					<div>
						一.String与Date(java.util.Date)互转 1.1 String -&gt; Date Java代码   String dateStr = &quot;2010/05/04 12: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGEmko3.html" rel="bookmark" class="title">个人作业Week7</a>
					<div>
						1.在做个人项目的时候,由于很久都没有写这么大的程序了,对程序的感觉还没有恢复,因此,没能完全完成个人项目.现在回去看个人项目的代码(针对完成的代码来看),完全就是一个大泥球,代码的结构性太差,基本上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nvDP70.html" rel="bookmark" class="title">&lbrack;BZOJ1677&rsqb;&lbrack;Usaco2005 Jan&rsqb;Sumsets 求和</a>
					<div>
						1677: [Usaco2005 Jan]Sumsets 求和 Time Limit: 5 Sec  Memory Limit: 64 MB Submit: 1031  Solved: 603 [Su ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGPnpb0.html" rel="bookmark" class="title">Maven学习总结二：使用myEclipse和命令行构建Maven项目</a>
					<div>
						一:使用myEclipse构建一个Maven项目 1.选择菜单 File -&gt; new -&gt; Other 2.选择Maven Project 3.默认选择.直接下一步 4.在Filter里 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38wywW0.html" rel="bookmark" class="title">jquery parent&lpar;&rpar;和parents&lpar;&rpar;区别</a>
					<div>
						parent(exp) 取得一个包含着所有匹配元素的唯一父元素的元素集合. 你可以使用可选的表达式来筛选. 查找段落的父元素中每个类名为selected的父元素. HTML 代码: &lt;div&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZOEg3.html" rel="bookmark" class="title">textarea 在浏览器中固定大小和禁止拖动</a>
					<div>
						HTML 标签 textarea 在大部分浏览器中只要指定行(rows)和列(cols)属性,就可以规定 textarea 的尺寸,大小就不会改变,不过更好的办法是使用 CSS 的 height 和  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a1YEn0.html" rel="bookmark" class="title">vsphere client 登陆ESXI主机&OpenCurlyDoubleQuote;您无权登录次服务器&rdquo;</a>
					<div>
						vCenter安装在虚拟机上,安装好后想调整下内存,直接把虚拟机关闭了电源,突然一想服务器都被我关了,还拿什么修改内存,完蛋! 突然想起,在使用vCenter之前,都是用vsphere client  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xZXRQ4.html" rel="bookmark" class="title">学习Linux系统的方法有很多，适合自己的才是最好。</a>
					<div>
						综观现在互联网+的发展以及应用,作为一个从事IT行业的人员,应该懂得Linux占比多大份量,所以说,去掌握Linux是一种相当重要的谋生途径,当然,如果你对它产生情感那更好. 这篇文章主要是本人结合自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Nj6qy4.html" rel="bookmark" class="title">依赖注入之针对不同类型变量的几种注入方式</a>
					<div>
						控制反转和依赖注入讲的都是一个概念,只不过是站在了不同的角度,所谓的依赖注入: 是指在运行期,由外部容器动态地将依赖对象注入到组件中.当spring容器启动后,spring容器初始化,创建并管理bea ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rzAe73.html" rel="bookmark" class="title">有名管道通讯</a>
					<div>
						一.有名管道 1.有名管道又称FIFO文件,我们对有名管道的操作可以采取操作文件的方式,如使用open, read,write. 2.FIFO文件与普通文件不同处 (1). 读取FIFO文件的进程只能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MD8DBYM.html" rel="bookmark" class="title">Codeforces Round &num;285 &lpar;Div&period; 2&rpar;   C - Misha and Forest</a>
					<div>
						思路:类似一个拓扑排序的题,根据 对度数为1的点,它所连的边的编号即为异或和这一 规律,直接进行拓扑排序即可. 每次对得到的节点度数减一,并且异或上他所连的节点. 代码: #include&lt;cs ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vjRBg3.html" rel="bookmark" class="title">alert、confirm、prompt的区别</a>
					<div>
						我们在开发一些后台管理系统的时候,经常会用到一些弹出框,今天我们一起看一下吧: alert:仅仅是一个提示的作用,通知用户,会阻线程,alert后面的代码,在用户点击确认后仍然会照常执行. confi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pLWxw4.html" rel="bookmark" class="title">Trie树  模板</a>
					<div>
						typedef struct node { int count; struct node *next[MAX]; }Trie; Trie *Newnode()//建立结点&amp;初始化a { int ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgExn83.html" rel="bookmark" class="title">POJ 2907 Collecting Beepers （DFS&plus;回溯）</a>
					<div>
						Description Karel is a robot who lives in a rectangular coordinate system where each place is design ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZqXAm0.html" rel="bookmark" class="title">屌丝一次</a>
					<div>
						1. 这么多年了,在北京终于亲眼看到冰雹了.2014年5月1日,下午4时左右,我们几个在篮球场上冒着雨淋痛快投球时,感觉雨中夹杂着冰雹,后来拔腿就跑.不相信是冰雹,白茫茫一片,最大的直径约2厘米. 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6pGAv3.html" rel="bookmark" class="title">Struts2&lowbar;GlobalResult</a>
					<div>
						&lt;global-results&gt; &lt;result name=&quot;&quot;&gt;&lt;/result&gt; &lt;global-results&gt; strut. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWj76G4.html" rel="bookmark" class="title">ecplise最有用的8个快捷键</a>
					<div>
						1. ctrl+shift+r 打开资源 这组快捷键可以让你打开你工作区中的任何一个文件.而你只需要按下键盘的文件名或前几个字母 美中不足的是这组快捷键并非在所有视图下都能用. 2.ctrl+o:快速 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bL5Ne4.html" rel="bookmark" class="title">Android开发笔记之&colon; 数据存储方式详解</a>
					<div>
						无论是神马平台,神马开发环境,神马软件程序,数据都是核心.对于开发平台来讲,如果对数据的存储有良好的支持,那么对应用程序的开发将会有很大的促进作用.总体的来讲,数据存储方式有三种:一个是文件,一个是数 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.021 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
